/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: Regex.cpp,v 1.3 2006/07/13 16:25:43 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#include <Regex.hh>
#include <Ferris/FerrisBoost.hh>

using namespace std;

namespace Ferris
{
//     static char *get_regerror (int errcode, const regex_t *compiled)
//     {
//         size_t length = regerror (errcode, compiled, NULL, 0);
//         char *buffer = (char*)malloc (length);
//         (void) regerror (errcode, compiled, buffer, length);
//         return buffer;
//     }

//     string
//     getErrorString( int e, const Regex& r)
//     {
//         char* estr = get_regerror( e, &r.RE );
//         string ErrorString = estr;
//         free(estr);
//         return ErrorString;
//     }


    /********************************************************************************/
    /********************************************************************************/
    /********************************************************************************/

    void Regex::setup()
    {
        if( REstr.empty() )
            m_regex = 0;
        else
            m_regex = toregexh( REstr );
        
//         memset( &RE, 0, sizeof(regex_t) );
//         if( m_cflags == -1 )
//         {
//             m_cflags = REG_EXTENDED | REG_NOSUB;// | REG_NEWLINE;
//         }
    
//         switch( int rc = regcomp( &RE, REstr.c_str(), m_cflags) )
//         {
//         case 0: // success
//             break;

//         default:
// //        cerr << "Regex.cpp: Invalid regex given:" << re << endl;
//             Throw_FerrisRegExCompileError( getErrorString( rc, *this )  );
//         }
    }
    
//     Regex::Regex( const string& re, int cflags)
//         :
//         REstr(re),
//         m_cflags( cflags )
//     {
// //    cerr << "Regex::Regex() re:" << re << endl;
//         setup();
//     }

    Regex::Regex( const string& re )
    :
    REstr(re),
    m_cflags( -1 ),
    m_regex( 0 )
    {
//    cerr << "Regex::Regex() re:" << re << endl;
        setup();
    }

    Regex::~Regex()
    {
//        regfree( &RE );

    }


//     bool
//     Regex::operator()( const string& s, int EFLAGS ) const
//     {
    
//         int rc = regexec( &RE, (char*)s.c_str(), 0, NULL, EFLAGS );

//         switch(rc)
//         {
//             /*
//              * Matched
//              */
//         case 0:
//             return true;

//         case REG_NOMATCH:
//             return false;

//         case REG_ESPACE:
//             Throw_FerrisOutOfMemory("",0);

//         default:
//             break;
//         }
//         Throw_FerrisRegExCompileError( getErrorString( rc, *this )  );
//     }


    bool
    Regex::operator()( const string& s ) const
    {
        if( !m_regex )
            return false;
        
        return regex_search( s, m_regex, boost::match_any );
    }




///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

 
FerrisRegExCompileError::FerrisRegExCompileError(
    const FerrisException_CodeState& state,
    fh_ostream log,
    const std::string& errorString,
    Attribute* a )
    :
    FerrisVFSExceptionBase( state, log, errorString.c_str(), a ),
    ErrorString( errorString )
{
    setExceptionName("FerrisRegExCompileError");
}



 
};
