/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: Regex.hh,v 1.3 2006/07/13 16:25:43 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/
#ifndef _ALREADY_INCLUDED_FERRIS_REGEX_H_
#define _ALREADY_INCLUDED_FERRIS_REGEX_H_

#include <Ferris/HiddenSymbolSupport.hh>
#include <Ferris/TypeDecl.hh>
//#include <Ferris/FerrisBoost.hh>
#include <SmartPtr.h>

namespace boost {
    namespace serialization {
        class access;
    }
}

namespace Ferris
{
    

//     class Regex;
//     FERRIS_SMARTPTR( Regex, fh_regex );
    
};

#include <Ferris/Ferris.hh>
#include <regex.h>

namespace Ferris
{
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

class FERRISEXP_API Regex : public Handlable // , public Object
{
    friend class FerrisRegExCompileError;

    fh_rex m_regex;
//    regex_t RE;
    std::string REstr;
    int m_cflags;
    
    friend std::string getErrorString( int e, const Regex& r);

    friend class boost::serialization::access;
    template<class Archive >
    void serialize(Archive & ar, const unsigned int version)
        {
            ar & REstr;
            ar & m_cflags;
            // after load, setup regex state.
            this->setup();
        }
    
    void setup();

public:

//    Regex( const std::string& re, int cflags = -1 );
    Regex( const std::string& re );
    ~Regex();

//    bool operator()( const std::string& s, int EFLAGS ) const;
    bool operator()( const std::string& s ) const;
    

};


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

class FERRISEXP_EXCEPTION FerrisRegExCompileError
    :
        public FerrisVFSExceptionBase
{
    std::string ErrorString;
    
public:

    FerrisRegExCompileError(
        const FerrisException_CodeState& state,
        fh_ostream log,
        const std::string& errorString,
        Attribute* a=0);

    ~FerrisRegExCompileError() throw ()
        {
        }

    
    
};
#define Throw_FerrisRegExCompileError(estr) \
throw FerrisRegExCompileError( \
FerrisException_CodeState( __FILE__ ,  __LINE__ , __PRETTY_FUNCTION__ ), \
(Enamel::get__t_l1w()), (estr), 0)


 
};

#endif // #ifndef _ALREADY_INCLUDED_FERRIS_REGEX_H_





