/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: SyncDelayer.hh,v 1.2 2007/12/11 21:30:12 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#ifndef _ALREADY_INCLUDED_FERRIS_SYNC_DELAYER_H_
#define _ALREADY_INCLUDED_FERRIS_SYNC_DELAYER_H_

#include <Functor.h>
#include <map>

namespace Ferris
{
    class SyncDelayer
    {
    public:
        explicit SyncDelayer();
        ~SyncDelayer();


        typedef Loki::Functor< void, LOKI_TYPELIST_1( SyncDelayer* ) > f_functor;
        static bool exists();
        static void add( void* key, const f_functor& f );
    private:
        static int s_count;
        typedef std::map< void*, f_functor > m_flist_t;
        static m_flist_t m_flist;
    };
};

#endif
