/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: libferrismpeg3_factory.cpp,v 1.2 2006/12/07 06:47:22 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#include <FerrisEAPlugin.hh>

using namespace std;
namespace Ferris
{
    

static Factory::EndingList EL()
{
    static Factory::EndingList r;
    static bool virgin = true;

    if( virgin )
    {
        virgin = false;
        
        r.push_back( make_pair( string("name"), string(".mp3") ));
        r.push_back( make_pair( string("name"), string(".mpg") ));
        r.push_back( make_pair( string("name"), string(".mpeg") ));
        r.push_back( make_pair( string("name"), string(".avi") ));
        r.push_back( make_pair( string("name"), string(".mp2") ));
        r.push_back( make_pair( string("name"), string(".ac3") ));
        r.push_back( make_pair( string("name"), string(".ifo") ));
        r.push_back( make_pair( string("name"), string(".dat") ));
    }
    
    return r;
}



extern "C"
{
        bool hasState()
        {
            return true;
        }
    

    MatchedEAGeneratorFactory* MakeFactory()
    {
        return new GModuleMatchedEAGeneratorFactory(
             Factory::ComposeEndsWithMatcher( EL() ),
             AUTOTOOLS_CONFIG_LIBDIR + "/ferris/plugins/eagenerators/libferrismpeg3.so" );
    }
    
}
};
