/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2003 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: libferrisxineea_factory.cpp,v 1.3 2006/12/07 06:47:22 ben Exp $

    *******************************************************************************
    *******************************************************************************
    ******************************************************************************/

#include <FerrisEAPlugin.hh>

using namespace std;

namespace Ferris
{
    /**
     */
    namespace 
    {
        static fh_matcher getMatcher()
        {
            static fh_matcher m;
            static Factory::EndingList r;
            static bool virgin = true;

            if( virgin )
            {
                virgin = false;

                r.push_back( make_pair( string("name"), string(".avi") ));
                r.push_back( make_pair( string("name"), string(".AVI") ));
                r.push_back( make_pair( string("name"), string(".mkv") ));
                r.push_back( make_pair( string("name"), string(".MKV") ));
                r.push_back( make_pair( string("name"), string(".mpg") ));
                r.push_back( make_pair( string("name"), string(".mp4") ));
                r.push_back( make_pair( string("name"), string(".ogm") ));

                m = Factory::ComposeEndsWithMatcher( r );
            }
    
            return m;
        }

        static bool r1 = RegisterEAGeneratorModule(
            getMatcher(),
            AUTOTOOLS_CONFIG_LIBDIR + "/ferris/plugins/eagenerators/libferrisxineea.so",
            "xine_metadata",
            false, // dyn
            true,  // state
            AttributeCreator::CREATE_PRI_MED );


        bool        writable  = false;
        string      libname   = AUTOTOOLS_CONFIG_LIBDIR + "/ferris/plugins/eagenerators/libferrisxineea.so";
        const char* shortname = "xine";
        bool ri1 = Context::RegisterImageEAGeneratorModule(
            "avi", writable, libname, shortname );
        bool ri2 = Context::RegisterImageEAGeneratorModule(
            "mkv", writable, libname, shortname );
        bool ri3 = Context::RegisterImageEAGeneratorModule(
            "mpg", writable, libname, shortname );
        bool ri4 = Context::RegisterImageEAGeneratorModule(
            "ogg", writable, libname, shortname );
        bool ri5 = Context::RegisterImageEAGeneratorModule(
            "mp4", writable, libname, shortname );
        bool ri6 = Context::RegisterImageEAGeneratorModule(
            "ogm", writable, libname, shortname );
        
    };
};
