#!/usr/bin/perl -w

$dbname=`cat ~/.ferris/rdfdb/ferris-db-name`;
$dbops=`cat ~/.ferris/rdfdb/ferris-db-options`;
$dbstorage=`cat ~/.ferris/rdfdb/ferris-storage-name`;
chomp($dbname);
chomp($dbops);
chomp($dbstorage);

$rdfproccmd="rdfproc -s $dbstorage -t \"$dbops\"  $dbname ";
print "$rdfproccmd\n";

while(<>)
  {
    $line = $_;

    if( $line =~ m/nana_-_02/i )
      {
	print "NANA LINE:$line\n";
      }
    if( $line =~ s/name:obj value:(.*)/$1/g ) 
      {
	chomp($line);
	$objnode = $line;
#	print "found objnode:$objnode\n";
      }
    if( $line =~ s/name:bnode value:\((.*)\)/$1/g ) 
      {
	chomp($line);
	$bnode = "_:$line";
#	print "found bnode:$bnode\n";
      }
    if( $line =~ s/name:pred value:\[(.*)\]/$1/g ) 
      {
	chomp($line);
	$pred = "$line";

	if( $pred eq "file-view-history"
	    || $pred eq "view-command"
	    || $pred eq "view-time"
	    || $pred eq "most-recent-view-command"
	    || $pred eq "most-recent-view-time"
	    || $pred eq "most-recent-view-sub-contexts"
	  )
	  {
#	    print "found pred:$pred\n";
	    $pred = "http://witme.sf.net/libferris.web/rdf/ferris-attr/$pred";
	  }
	else
	  {
	    $pred = 0;
	    $bnode = 0;
	    $objnode = 0;
	  }
      }

    if ( $bnode && $pred && $objnode  ) {
      print "got bnode:$bnode pred:$pred obj:$objnode\n";
      $bnode =~ s/\"/\\\"/g;
      $pred =~ s/\"/\\\"/g;
      $objnode =~ s/\"/\\\"/g;

      $cmd = "$rdfproccmd add \"$bnode\" \"$pred\" \"$objnode\"";
      print "$cmd\n";
      system $cmd;
      $pred = 0;
      $bnode = 0;
      $objnode = 0;
    }
 

   
}
