/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: libexternal_factory.cpp,v 1.2 2005/12/20 11:36:04 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#include <FerrisContextPlugin.hh>
#include <mapping.hh>

using namespace std;
namespace Ferris
{


extern "C"
{
    
    FERRISEXP_EXPORT fh_ommatchers GetOverMountMatchers(RootContextFactory* rf)
    {
        fh_ommatchers ret;

        vector<string> v = emap::getEndsWithStrings();

        for( vector<string>::iterator iter = v.begin();
             iter != v.end(); ++iter )
        {
            ret.push_back( Factory::MakeEndsWithMatcher("name", *iter ) );
        }
        
        return ret;
    }

    FERRISEXP_EXPORT string getName()
    {
        return "external";
    }

    FERRISEXP_EXPORT bool tryToOverMountToFindEA()
    {
        return false;
    }
}

 
};
