/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: mbox.cpp,v 1.1 2005/07/12 04:05:47 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#include <iostream>
using namespace std;


#ifdef GCC_HASCLASSVISIBILITY
int main( int argc, char** argv )
{
    cerr << "mbox client disabled for libferris builds that have hidden symbols" << endl;
    exit(1);
}
#else

#include <libnativembox.cpp>
using namespace Ferris;

int main( int argc, char** argv )
{
    try
    {
        string mbox = "input";
        if( argc > 1 )
        {
            mbox = argv[1];
        }

        const string& rdn = mbox;
        fh_ifstream ss( rdn );

        fh_context omc = Resolve( mbox );
    
        fh_mbcontext ctx = new MBoxContext( omc, rdn, ss );

        cout << "About to read() " << endl;
        ctx->read();

        cout << "About to get the subcontext names!" << endl;
        Context::SubContextNames_t names = ctx->getSubContextNames();
        cout << "got the subcontext names!" << endl;

        for(Context::SubContextNames_t::const_iterator iter = names.begin();
            iter != names.end();
            iter++ )
        {
            fh_context sub = ctx->getSubContext( *iter );
            fh_istream ss  = sub->getIStream();

            cout << "=======" << sub->getDirPath() << "========" << endl;
            while( ss->good() )
            {
                string s;
                getline( ss, s );
                cout << s << endl;
            }
        }
        
    }
    catch( exception& e )
    {
        cerr << "mbox test client cought e:" << e.what() << endl;
    }
    
    return 0;
}
#endif






