/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: ffilter.g,v 1.2 2006/08/13 11:41:37 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#lexmember <<
  protected:
    int          isWS;
    int          begline;
    virtual void tabAdjust() {}
>>

<<

#include "Common.hh"
#include "ferrisPcctsContext.hh"
#include "DLGLexer.h"

//#include <iostream>

using namespace std;
using namespace Ferris;


void dump( AST* node, const string& s )
{
	if( !node )
		return;

	cout << "1... s:" << s << "   " << node->getName() << endl;

	dump( (AST*)node->down(), s + node->getName());

	for( AST* n = node;  n = (AST*)n->right(); )
	{
		cout << "2... s:" << s << "   " << n->getName() << endl;
		dump( (AST*)n->down(), s + n->getName());
	}


}

int main()
{
	fh_ifstream ss("input");

	MyParserBlackBox<DLGLexer, FFilterParser, ANTLRToken> p(ss);
	ASTBase* root = NULL;
	p.parser()->interp( &root );


	cout << root << endl;

	AST* node = (AST*)root;
	string s = node->getName();

	dump( node, "" );

	return 0;
}

>>

#lexclass START

#token Eof       "@"
#token "[\ \t]+"	<<skip();>>
#token "\n"		<<skip(); newline();>>

#token KOCTETSTR          "[\ a-zA-Z0-9\-\_\*\$\^\]\[\\\/\~\:]+"
//#token VOCTETSTR          "[a-zA-Z0-9\-\_\*\$\^\]\[\\\/\~\:]+"
//#token VOCTETSTR          "[\ a-zA-Z0-9\-\_\*\$\^\]\[\\\/\~\.\?\+]+"


#token EQREGEX "\=\~" << mode(EAVALUECLASS); >>
#token EQLT    "<="   << mode(EAVALUECLASS); >>
#token EQGT    ">="   << mode(EAVALUECLASS); >>
#token EQ      "=="   << mode(EAVALUECLASS); >>
#token EQLTSC  "<\?=" << mode(EAVALUECLASS); >>
#token EQGTSC  ">\?=" << mode(EAVALUECLASS); >>
#token EQSC    "=\?=" << mode(EAVALUECLASS); >>
#tokclass COMPARISON {EQREGEX EQLT EQGT EQ EQLTSC EQGTSC SQSC} 

/******************************/
/******************************/
/******************************/

#lexclass EAVALUECLASS
#token EAVALUETERMINATOR "\)"    <<
                             replchar('\0');
                             mode(START);
                         >>
#token           "~[]" <<more();>>
#tokclass WIDEEAVALUE {EAVALUETERMINATOR}

/******************************/
/******************************/
/******************************/

#lexclass START

<<
// justGG
>>
                             
class FFilterParser 
{

<<

public:

/* #include <string> */
/* #include <sstream> */
/* #include <iostream> */

    
void foobar2()
{
int x = 2;
}

/* std::string  */
/* edecodeToString(SetWordType *a) */
/* { */
/*     using namespace std; */
/*     stringstream retss; */

/* 	register SetWordType *p = a; */
/* 	register SetWordType *endp = &(p[bsetsize]); */
/* 	register unsigned e = 0; */

/* 	if ( set_deg(a)>1 ) retss << " {"; */
/* 	do { */
/* 		register SetWordType t = *p; */
/* 		register SetWordType *b = &(bitmask[0]); */
/* 		do { */
/* 			if ( t & *b ) retss << " " << token_tbl[e]; */
/* 			e++; */
/* 		} while (++b < &(bitmask[sizeof(SetWordType)*8])); */
/* 	} while (++p < endp); */
/* 	if ( set_deg(a)>1 ) retss << " }"; */
/*     return retss.str(); */
/* } */

/* std::string getSyntaxErrorString( ANTLRChar *egroup, SetWordType *eset, ANTLRTokenType etok, int k) */
/* { */
/*     using namespace std; */
/*     stringstream retss; */
/* 	int line; */
    
/* 	line = LT(1)->getLine(); */

/*     syntaxErrCount++;                                   /\* MR11 *\/ */

/*     /\* MR23  If the token is not an EOF token, then use the ->getText() value. */

/*              If the token is the EOF token the text returned by ->getText()  */
/*              may be garbage.  If the text from the token table is "@" use */
/*              "<eof>" instead, because end-users don't know what "@" means. */
/*              If the text is not "@" then use that text, which must have been */
/*              supplied by the grammar writer. */
/*      *\/ */
/* 	const char * errorAt = LT(1)->getText(); */
/* 	if (LA(1) == eofToken) { */
/*   	  errorAt = parserTokenName(LA(1)); */
/*   	  if (errorAt[0] == '@') errorAt = "<eof>"; */
/* 	} */
/*     retss << "line:" << line << " syntax error at \"" << errorAt << "\""; */
/* 	if ( !etok && !eset ) */
/*     { */
/*         retss << endl; */
/*         return retss.str(); */
/*     } */
/* 	if ( k==1 ) */
/*         retss << " missing"; */
/* 	else */
/* 	{ */
/* 		retss << "; \"" << LT(k)->getText() << "\" not"; */
/* 		if ( set_deg(eset)>1 ) retss << " in"; */
/* 	} */
/* 	if ( set_deg(eset)>0 ) retss << edecodeToString(eset); */
/* 	else retss << " " << token_tbl[etok]; */
/* 	if ( strlen(egroup) > 0 ) retss << " in " << egroup; */
/* 	retss << endl; */
/*     return retss.str(); */
/* } */

/* void syn(_ANTLRTokenPtr, ANTLRChar *egroup, SetWordType *eset, */
/* 	ANTLRTokenType 	etok, int k) */
/* { */
/*     using namespace std; */
/*     string errorString = getSyntaxErrorString( egroup, eset, etok, k ); */
/*     cerr << errorString << endl; */
/*     syntaxErrors.push_back( errorString ); */
/* } */


>>


interp
	:	a:filter Eof!
	;

filter
	:	eaterm   <<{ /*#0->preorder(); printf("\n"); */ }>>
	;


eaterm
	:
		"\("! 
		 (
		     eamatch
		   | ( "\!"^ eaterm  "\)"! )
		   | ( "\|"^ (eaterm)+ "\)"! )
		   | ( "\&"^ (eaterm)+ "\)"! )
		 )
		
		
	;

// eavalue eats the terminating ')' char
eamatch : 	eakey COMPARISON^ eavalue;
eakey  	:	KOCTETSTR ;
eavalue :	WIDEEAVALUE ;

}

