/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: libferrisredland.cpp,v 1.6 2007/01/21 21:30:09 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#include <FerrisEAPlugin.hh>
#include <Ferris/Redland_private.hh>
#include <libferrisredlandeashared.hh>

using namespace std;

namespace Ferris
{
    using namespace RDF;
    using namespace redlandea;

//     static const char* RDF_URL_HAS_OUTOFLINE_EA
//     = "http://witme.sf.net/libferris.web/rdf/ferris-attr/url-has-outofline-ea";
//     static fh_node get_RDF_URL_HAS_OUTOFLINE_EA_Node()
//     {
//         static fh_node pred = 0;

//         if( !pred )
//             pred = Node::CreateURI( RDF_URL_HAS_OUTOFLINE_EA );
        
//         return pred;
//     }
    
    class FERRISEXP_DLLLOCAL EAGenerator_Redland : public MatchedEAGeneratorFactory
    {
    protected:

        virtual void Brew( const fh_context& a );

        void generateAttribute( const fh_context& a,
                                const std::string& rdn,
                                bool forceCreate = false );
        
    public:

        EAGenerator_Redland();

        fh_attribute CreateAttr(
            const fh_context& a,
            const string& rdn,
            fh_context md = 0 )
            throw(
                FerrisCreateAttributeFailed,
                FerrisCreateAttributeNotSupported
                );

        virtual bool isDynamic()
            {
                return true;
            }
        virtual bool tryBrew( const fh_context& ctx, const std::string& eaname );
    
    
        bool
        supportsCreateForContext( fh_context c )
            {
                return true;
            }
    };


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

//     static const std::string ATTR_PREFIX   = "http://witme.sf.net/libferris.web/rdf/ferris-attr/";
//     static const std::string SCHEMA_PREFIX = "http://witme.sf.net/libferris.web/rdf/ferris-schema/";
    
//     static std::string getURI( const std::string& baseuri,
//                                const std::string& ferrisEAName,
//                                const std::string& pfx = "" )
//     {
//         std::string ret = baseuri;
//         if( !pfx.empty() && starts_with( ferrisEAName, pfx ) )
//             ret += ferrisEAName.substr( pfx.length() );
//         else
//             ret += ferrisEAName;

//         return ret;
//     }

//     static std::string getPredicateURI( const std::string& rdn )
//     {
//         if( starts_with( rdn, "schema:" ))
//         {
//             return getURI( SCHEMA_PREFIX, rdn, "schema:" );
//         }
//         return getURI( ATTR_PREFIX, rdn );
//     }
    

    
// class RedlandByteArrayAttribute
//     :
//         public EA_Atom_ReadWrite
// {

// protected:

//     ferris_ios::openmode getSupportedOpenModes()
//         {
//             return ios::in | ios::out | ios::trunc | ios::binary | ios::ate;
//         }

//     void createOnDiskAttribute( const fh_context& parent, const std::string& uri )
//         {
//             string v = "";

//             RDF::fh_model  m = getDefaultFerrisModel();

//             try
//             {
//                 m->insert( Node::CreateURI( parent->getURL() ),
//                            Node::CreateURI( uri ),
//                            Node::CreateLiteral( v ) );
//             }
//             catch( exception& e )
//             {
//                 fh_stringstream ss;
//                 ss << "Failed to create RDF EA for c:" << parent->getURL()
//                    << " attribute name:" << uri
//                    << endl;
//                 ThrowFromErrno( 0, tostr(ss), 0 );
//             }
//         }
    
    
// public:

//     virtual fh_iostream getStream( Context* c, const std::string& rdn, EA_Atom* atom )
//         {
//             fh_stringstream ss;
            
//             fh_model  m = getDefaultFerrisModel();
//             fh_node obj = m->getObject( Node::CreateURI( c->getURL() ),
//                                         Node::CreateURI( getPredicateURI( rdn ) ) );
//             if( obj )
//             {
//                 ss << obj->toString();
//             }
//             else
//             {
//                 fh_stringstream ss;
//                 ss << "reading attribute:" << rdn;
//                 Throw_NoSuchAttribute( tostr(ss), c );
//             }
//             cerr << "RedlandAttr::getStream() c:" << c->getURL()
//                  << " pred:" << getPredicateURI( rdn )
//                  << " data:" << tostr( ss ) 
//                  << endl;
            
//             return ss;
//         }

//     virtual void setStream( Context* c, const std::string& rdn, EA_Atom* atom, fh_istream ss )
//         {
//             cerr << "RedlandAttr::setStream() start" << endl;
//             RDF::fh_model  m = getDefaultFerrisModel();

//             fh_node subj = Node::CreateURI( c->getURL() );
//             fh_node pred = Node::CreateURI( getPredicateURI( rdn ) );

//             cerr << "RedlandAttr::setStream() pred:" << pred->toString() << endl;
            
//             m->erase( subj, pred, m->findObjects( subj, pred ) );
//             m->insert( subj, pred, Node::CreateLiteral( StreamToString(ss) ) );
//         }

    
    
//     RedlandByteArrayAttribute(
//         const fh_context& parent,
//         const string& rdn,
//         const string& uri,
//         bool forceCreate = false
//         )
//         :
//         EA_Atom_ReadWrite( this, &RedlandByteArrayAttribute::getStream,
//                            this, &RedlandByteArrayAttribute::getStream,
//                            this, &RedlandByteArrayAttribute::setStream )
//         {
//             if( forceCreate )
//             {
//                 cerr << "RedlandByteArrayAttribute() making EA for earl:" << parent->getURL()
//                      << " predicate::" << uri
//                      << endl;
//                 createOnDiskAttribute( parent, uri );
//             }
//         }

//     ~RedlandByteArrayAttribute()
//         {
//         }

//     static RedlandByteArrayAttribute* Create( const fh_context& parent,
//                                               const string& rdn,
//                                               bool forceCreate = false )
//         {
//             return new RedlandByteArrayAttribute( parent,
//                                                   rdn,
//                                                   getPredicateURI( rdn ),
//                                                   forceCreate );
//         }
// };


/**
 * We allow the schema:eaname to be saved on disk as an RDF EA aswell.
 * This is a little tricky, if its not saved on disk then we return
 * the URL for FXD_BINARY_NATIVE_EA as the data in Stream requests.
 * if the user updates the stream with some data then we save it to
 * disk and return the disk data in future Stream requests.
 */
class FERRISEXP_DLLLOCAL RedlandByteArrayAttributeSchema
    :
        public RedlandByteArrayAttribute
{
    typedef RedlandByteArrayAttributeSchema _Self;
    typedef RedlandByteArrayAttribute       _Base;

    
public:

    virtual fh_iostream getStream( Context* c, const std::string& rdn, EA_Atom* atom )
        {
            RDF::fh_model  m = getDefaultFerrisModel();

            try
            {
                return _Base::getStream( c, rdn, atom );
            }
            catch( NoSuchAttribute& e )
            {
                // try for subtree schema
                if( c->isParentBound() )
                {
                    string subtreeurl = getStrAttr( c->getParent(), "subtree" + rdn, "" );
                    if( !subtreeurl.empty() )
                    {
                        fh_stringstream ss;
                        ss << subtreeurl;
                        return ss;
                    }
                }
                Factory::xsdtypemap_t tmap;
                Factory::makeBasicTypeMap( tmap );
                fh_context schema = tmap[ FXD_BINARY_NATIVE_EA ];
                
                fh_stringstream ss;
                ss << schema->getURL();
                return ss;
            }
        }
//     virtual void setStream( Context* c, const std::string& rdn, EA_Atom* atom, fh_istream ss )
//         {
//             try
//             {
//                 _Base::setStream( c, rdn, atom, ss );
//             }
//             catch( NoSuchAttribute& e )
//             {
//                 createOnDiskAttribute( c->getParent(), getPredicateURI( rdn ) );
//                 _Base::setStream( c, rdn, atom, ss );
//             }
//         }
    
    RedlandByteArrayAttributeSchema( const fh_context& parent,
                                     const string& rdn,
                                     const string& uri,
                                     bool forceCreate = false
        )
        :
        _Base( parent, rdn, uri, forceCreate )
        {
            LG_RDF_D << "RedlandByteArrayAttributeSchema() parent:" << parent->getURL()
                     << " rdn:" << rdn
                     << " uri:" << uri
                     << " forceCreate:" << forceCreate
                     << endl;

//             if( forceCreate )
//             {
//                 RDF::fh_model m = getDefaultFerrisModel();
//                 fh_node subj = Node::CreateURI( parent->getURL() );
//                 fh_node pred = Node::CreateURI( getPredicateURI( rdn ) );
//                 m->insert( subj, pred, Node::CreateLiteral( "" ) );
//             }
            
        }

    
    static RedlandByteArrayAttributeSchema* Create( const fh_context& parent,
                                                    const string& rdn,
                                                    bool forceCreate = false )
        {
//             RDF::fh_model m = getDefaultFerrisModel();

//             fh_node subj = Node::CreateURI( parent->getURL() );
//             fh_node pred = Node::CreateURI( getURI( SCHEMA_PREFIX, rdn, "schema:" ) );
//             m->erase( subj, pred, m->findObjects( subj, pred ) );
            
            return new RedlandByteArrayAttributeSchema( parent,
                                                        rdn,
                                                        redlandea::getPredicateURI( rdn ),
                                                        false ); // forceCreate );
        }
    
};




///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


EAGenerator_Redland::EAGenerator_Redland()
    :
    MatchedEAGeneratorFactory()
{
}

void
EAGenerator_Redland::generateAttribute( const fh_context& a,
                                        const std::string& rdn,
                                        bool forceCreate )
{
    LG_RDF_D << "EAGenerator_Redland::generateAttribute() a:" << a->getURL()
             << " rdn:" << rdn
             << endl;
    
    a->addAttribute( rdn,
                     (EA_Atom*)RedlandByteArrayAttribute::Create( a, rdn, forceCreate ),
                     FXD_BINARY_NATIVE_EA
        );

    //
    // Attach schema
    //
    if( !starts_with( rdn, "schema:" ))
    {
        string schema_name      = "schema:" + rdn;

        if( ! a->isAttributeBound( schema_name, false ))
        {
            if( ! a->addAttribute(
                    schema_name,
                    (EA_Atom*)RedlandByteArrayAttributeSchema::Create( a, schema_name, forceCreate ),
                    XSD_SCHEMA ))
            {
                ostringstream ss;
                ss << "Can't create schema RDF statement for rdn:" << rdn
                   << " schema_name:" << schema_name
                   << " forceCreate:" << forceCreate;
                Throw_FerrisCreateAttributeFailed( tostr(ss), 0 );
            }
        }
    }
}



void
EAGenerator_Redland::Brew( const fh_context& a )
{
//    Time::Benchmark("Redland::Brew() " + a->getURL() );
//    cerr << "EAGenerator_Redland::Brew() url:" << a->getURL() << endl;
    
    static bool brewing = false;
    if( brewing )
        return;
    Util::ValueRestorer< bool > dummy1( brewing, true );
    
    try
    {
        stringlist_t rdf_ea_names;

        string            earl = a->getURL();
        RDF::fh_model        m = getDefaultFerrisModel();

        fh_node mdnode = redlandea::tryToGetRedlandEASubjectNode( a );

        LG_RDF_D << "Brew() "
                 << " url:" << a->getURL()
                 << " mdnode:" << toVoid(mdnode)
                 << endl;
        
//        cerr << "EA_Redland::Brew() earl:" << earl << " hasEA:" << isBound(hasEA) << endl;

        if( !mdnode )
            return;

        LG_RDF_D << "Brew() "
                 << " url:" << a->getURL()
                 << " uuid:" << tryToGetUUIDNode(a)->toString()
                 << " mdnode:" << mdnode->toString()
                 << endl;
        
        RDF::ObjectIterator iter = m->getArcsOut( mdnode );
        bool virgin = true;
        for( ; iter != ObjectIterator(); ++iter )
        {
            if( virgin )
            {
                virgin = false;
                a->setHasDynamicAttributes( true );
            }
            
            LG_RDF_D << "Brew() "
                     << " url:" << a->getURL()
                     << " mdnode:" << toVoid(mdnode)
                     << " iter:" << (*iter)->toString()
                     << endl;
            
            if( !(*iter)->isResource() )
                continue;
            
            string rdn = (*iter)->getURI()->toString();
//             cerr << "Found another arc out for earl:" << earl
//                  << " rdn:" << rdn
//                  << endl;

//             if( rdn == RDF_URL_HAS_OUTOFLINE_EA )
//                 continue;

            rdn = redlandea::stripPredicateURIPrefix( rdn );
            
            generateAttribute( a, rdn );
            rdf_ea_names.push_back( rdn );
        }

        if( !virgin )
        {
            /*
             * Add a new EA showing the names of all the RDF EA
             */
            a->addAttribute( "rdf-ea-names",
                             Util::createCommaSeperatedList( rdf_ea_names ),
                             FXD_EANAMES,
                             true );
        }
    }
    catch( exception& e )
    {
        LG_RDF_ER << "Failed to load RDF EA, error:" << e.what() << endl;
    }

    LG_RDF_D << "Brew() "
             << " url:" << a->getURL()
             << " complete"
             << endl;
}

bool
EAGenerator_Redland::tryBrew( const fh_context& ctx, const std::string& eaname )
{
//    Time::Benchmark("Redland::tryBrew() " + ctx->getURL() );
    
//     cerr << "EAGenerator_Redland::tryBrew() url:" << ctx->getURL()
//          << " eaname:" << eaname
//          << endl;

    static bool brewing = false;
    if( brewing )
        return false;
    Util::ValueRestorer< bool > dummy1( brewing, true );

    LG_RDF_D << "tryBrew() "
             << " url:" << ctx->getURL()
             << " eaname:" << eaname
             << endl;
    
    bool ret = false;

    RDF::fh_model     m = getDefaultFerrisModel();
    string         earl = ctx->getURL();
    fh_node    mdnode = redlandea::tryToGetRedlandEASubjectNode( ctx );
    
    if( mdnode )
    {
        fh_node        pred = Node::CreateURI( redlandea::getPredicateURI( eaname ));
        fh_node     objnode = m->getObject( mdnode, pred );

//         cerr << "tryBrew() "
//              << " url:" << ctx->getURL()
//              << " eaname:" << eaname
//              << " mdnode:" << mdnode
//              << " objnode:" << objnode
//              << endl;
        
        if( objnode )
        {
            ret = true;
            generateAttribute( ctx, eaname );
            return ret;
        }
    }
    
    return ret;
}



fh_attribute
EAGenerator_Redland::CreateAttr( const fh_context& a,
                                 const string& urdn,
                                 fh_context md )
    throw(
        FerrisCreateAttributeFailed,
        FerrisCreateAttributeNotSupported
        )
{
    try
    {
        string rdn = urdn;

//        cerr << "EAGenerator_Redland::CreateAttr() rdn:" << rdn << endl;
        LG_RDF_D << "EAGenerator_Redland::CreateAttr() rdn:" << rdn << endl;
//        cerr << "EAGenerator_Redland::CreateAttr() rdn:" << rdn << endl;

        string      earl = a->getURL();
        RDF::fh_model  m = getDefaultFerrisModel();
        
        try
        {
            ensureRedlandEASubjectNode( a );
        }
        catch( exception& e )
        {
            fh_stringstream ss;
            ss << "Failed to create RDF EA for c:" << a->getURL()
               << " attribute name:" << rdn
               << " error:" << e.what()
                   << endl;
            ThrowFromErrno( 0, tostr(ss), 0 );
        }

        generateAttribute( a, rdn, true );
        fh_attribute ret = a->getAttribute( rdn );
        return ret;
    }
    catch( FerrisCreateAttributeFailed& e )
    {
        cerr << "RDF out of band EA module::create() e:" << e.what() << endl;
        throw e;
    }
    catch( exception& e )
    {
        fh_stringstream ss;
        ss << e.what();
        cerr << "RDF out of band EA module::create() e:" << e.what() << endl;
//        cerr << tostr(ss) << endl;
        Throw_FerrisCreateAttributeFailed( tostr(ss), 0 );
    }
}



///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

extern "C"
{
    FERRISEXP_EXPORT MatchedEAGeneratorFactory* CreateRealFactory()
    {
        fh_world w = getWorld();
        return new EAGenerator_Redland();
    }
};



 
};
